local _, ns = ...
local cfg = ns.cfg
local castbar = CreateFrame('Frame')

castbar.OnCastbarUpdate = function(self, elapsed)
    if(self.casting or self.channeling) then
        local duration = self.casting and self.duration + elapsed or self.duration - elapsed
        if (self.casting and duration >= self.max) or (self.channeling and duration <= 0) then
            self.casting = nil
            self.channeling = nil
            return
        end
        if (self.__owner.unit == 'player') then
            if (self.delay ~= 0) then
                if (self.casting) then
                    self.Time:SetFormattedText('%.1f | |cffff3500%s%.1f|r', duration, '+', self.delay)
                else
                    self.Time:SetFormattedText('%.1f | |cffff3500%s%.1f|r', duration, '-', self.delay)
                end
            else
                self.Time:SetFormattedText('%.1f | %.1f', duration, self.max)
            end
        else
            self.Time:SetFormattedText('%.1f | %.1f', duration, self.casting and self.max + self.delay or self.max - self.delay)
        end
        self.duration = duration
        self:SetValue(duration)
    else
        local alpha = self:GetAlpha() - 0.02
        if (alpha > 0) then
            self:SetAlpha(alpha)
        else
            self.fadeOut = nil
            self:Hide()
        end
    end
end

castbar.PostCastStart = function(self, unit)
    self:SetAlpha(1.0)
    if (self.casting) then
        self:SetStatusBarColor(unpack(self.CastingColor))
    else
        self:SetStatusBarColor(unpack(self.ChannelingColor))
    end
    if (self.Icon) then
		local texture = self.Icon:GetTexture()
		if (not texture or texture == 136235) then
			self.Icon:SetTexture(136243)
		end
	end
end

castbar.PostCastStop = function(self, unit, spellID)
    if (not self.fadeOut) then
        self:SetStatusBarColor(unpack(self.CompleteColor))
        self.fadeOut = true
    end
    self:SetValue(self.max)
    self:Show()
end

castbar.PostCastFail = function(self, unit, spellID)
    self:SetStatusBarColor(unpack(self.FailColor))
    self:SetValue(self.max)
    if (not self.fadeOut) then
        self.fadeOut = true
    end
    self:Show()
end

ns.castbar = castbar -- don't touch this ...